package com.qadeer.customer.feign;

import com.qadeer.customer.dto.CustomerRequest;
import com.qadeer.customer.dto.ProductDto;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@FeignClient(name = "seller-api", url = "http://localhost:8082/seller")
public interface FeignService {

    @GetMapping("/product/{id}")
    ProductDto getProductById(@PathVariable int id);

    @GetMapping("/product/{productName}/{productQuantity}")
    List<ProductDto> buyProductByName(@PathVariable("productName") String productName, @PathVariable("productQuantity") String productQuantity);

    @PostMapping(path = "/product/buy/json")
    List<ProductDto> buyProducts(@RequestBody CustomerRequest customerRequest);
}
