package com.qadeer.customer.service;


import com.qadeer.customer.dto.CustomerRequest;
import com.qadeer.customer.dto.ProductDto;
import com.qadeer.customer.feign.FeignService;
import com.qadeer.customer.repository.CustomerRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class CustomerService {

    @Autowired
    private CustomerRepository repository;

    @Autowired
    private FeignService feignService;

    public List<ProductDto> buyProductByName(String productName, String productQuantity) {
        List<ProductDto> productDto = feignService.buyProductByName(productName, productQuantity);
        return productDto;
    }

    public List<ProductDto> buyProducts(CustomerRequest customerRequest) {
        List<ProductDto> products = feignService.buyProducts(customerRequest);
        return products;
    }

    public ProductDto getProductById(int id) {
        ProductDto productDto = feignService.getProductById(id);
        return productDto;
    }
}
