package com.qadeer.seller.controller;

import com.qadeer.seller.dto.CustomerRequest;
import com.qadeer.seller.dto.ProductDto;
import com.qadeer.seller.feign.FeignService;
import com.qadeer.seller.model.Seller;
import com.qadeer.seller.service.SellerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/seller")
public class SellerController {

    @Autowired
    private SellerService service;

    @GetMapping("/hello")
    public String hello() {
        return "Hello";
    }

    @PostMapping
    public void createProduct(@RequestBody Seller seller) {
        service.saveProduct(seller);
    }

    @GetMapping("/{id}")
    public Seller getProduct(@PathVariable int id) {
        return service.getProduct(id);
    }

    @GetMapping("/product/{id}")
    public ResponseEntity<?> getProductById(@PathVariable int id) {
        ProductDto productDto = service.getProductById(id);
        return ResponseEntity.ok(productDto);
    }

    @PostMapping("/product/buy/json")
    public  ResponseEntity<?> buyProducts(@RequestBody CustomerRequest customerRequest) {
        List<ProductDto> productDtoList = service.buyProducts(customerRequest);
        return new ResponseEntity<>(productDtoList, HttpStatus.OK);
    }

}
