package com.qadeer.seller.feign;

import com.qadeer.seller.dto.CustomerRequest;
import com.qadeer.seller.dto.ProductDto;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(name = "inventory-api", url = "http://localhost:8083/inventory")
public interface FeignService {

    @GetMapping("/product/{id}")
    ProductDto getProductById(@PathVariable int id);

    @PostMapping("/product/buy/json")
    List<ProductDto> buyProducts(@RequestBody CustomerRequest customerRequest);
}
