package com.qadeer.seller.service;

import com.qadeer.seller.dto.CustomerRequest;
import com.qadeer.seller.dto.ProductDto;
import com.qadeer.seller.feign.FeignService;
import com.qadeer.seller.model.Seller;
import com.qadeer.seller.repository.SellerRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

import static com.qadeer.seller.constant.Constant.FILE_PATH;

@Service
public class SellerService {

    @Autowired
    private SellerRepository sellerRepository;

    @Autowired
    private FeignService feignService;

    FileWriter fw = new FileWriter(FILE_PATH);

    public SellerService() throws IOException {
    }

    public void saveProduct(Seller seller){
        sellerRepository.save(seller);
    };

    public Seller getProduct(int id) {
        return sellerRepository.findById(id).get();
    }

    public ProductDto getProductById(int id) {
        ProductDto productDto = feignService.getProductById(id);
        orderLogs(productDto);
        return productDto;
    }

    public void orderLogs(ProductDto productDto) {
//        String path = "/Users/aqadeer/Desktop/java-training-project-final/seller-service/orders.csv";
//        BufferedWriter bw = null;

        try {
            DateTimeFormatter dtf = DateTimeFormatter.ofPattern("dd/MMM/yyyy HH:mm:ss");
            LocalDateTime now = LocalDateTime.now();
            String myTime = dtf.format(now);
            String text = productDto.toString() + " " + myTime + "\n";
            Files.write(Paths.get(FILE_PATH), text.getBytes(), StandardOpenOption.APPEND);
//            bw = new BufferedWriter(fw);
//            bw.append(productDto.toString());
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        finally {
            //                bw.close();
        }

    }

    public List<ProductDto> buyProducts(CustomerRequest customerRequest) {
        List<ProductDto> productDtoList = feignService.buyProducts(customerRequest);
        return productDtoList;

    }
}
